"use strict";
exports.__esModule = true;
/**
 * Creates a type safe string enumeration from a list of strings, providing:
 * the list of all possible values, an object with all enum keys and the derived type of the enum in a single declaration.
 */
function createEnum() {
    var values = [];
    for (var _i = 0; _i < arguments.length; _i++) {
        values[_i] = arguments[_i];
    }
    var enumeration = {};
    values.forEach(function (v) { return (enumeration[v] = v); });
    return {
        "enum": enumeration,
        values: values
    };
}
exports.createEnum = createEnum;
